"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.epicCurrency = void 0;
class epicCurrency {
    // Constructor
    constructor(code, name, rate, symbol = null, image = null) {
        this.val = () => this.currency;
        this.changeRate = (rate) => {
            if (typeof rate == "number")
                this.currency.rate = rate;
            else
                throw new Error("Invalid Rate Provided!");
            return this;
        };
        this.clone = () => new epicCurrency(this.currency.code, this.currency.name, this.currency.rate, this.currency.symbol, this.currency.image);
        // Validate Currency Values
        if (typeof code != "string")
            throw new Error("Valid three digit ISO currency code is required!");
        if (typeof name != "string")
            throw new Error("Currency name is required!");
        if (typeof rate != "number")
            throw new Error("Please provide a valid currency rate!");
        if (typeof symbol != "string" && symbol !== null)
            throw new Error("Please provide a valid currency symbol!");
        if (typeof image != "string" && image !== null)
            throw new Error("Please provide a valid currency image!");
        this.currency = {
            code: code.toLowerCase(),
            name,
            rate,
            symbol,
            image,
        };
        return this;
    }
}
exports.epicCurrency = epicCurrency;
//# sourceMappingURL=epicCurrency.js.map