import { epicMoney } from "./epicMoney";
import { epicCurrency } from "./epicCurrency";
import { epicCurrencyList } from "./epicCurrencyList";
export interface STACK_DETAILS {
    description: string;
    quantity: number;
}
export interface STACK extends STACK_DETAILS {
    type: "ADD" | "DEDUCT";
    money: epicMoney;
    total: epicMoney;
    history: epicMoney;
}
export interface STATEMENT_ROW {
    description: string;
    currency: string;
    quantity: number;
    amount: number;
    total: number;
}
export declare type STATEMENT = STATEMENT_ROW[];
export declare class epicMoneyStack {
    protected currencyList: epicCurrencyList;
    protected moneyList: STACK[];
    constructor(currencyList: epicCurrencyList);
    add: (money: epicMoney, options?: STACK_DETAILS) => epicMoneyStack;
    deduct: (money: epicMoney, options?: STACK_DETAILS) => epicMoneyStack;
    stacks: () => STACK[];
    export: () => STATEMENT;
    import: (source: STATEMENT) => epicMoneyStack;
    total: (currency?: epicCurrency | undefined) => epicMoney;
}
//# sourceMappingURL=epicMoneyStack.d.ts.map